# How to Contribute

Always happy to get issues identified and pull requests!

### General considerations
1. Keep it small. The smaller the change, the more likely we are to accept.
2. Changes that fix a current issue get priority for review.
3. Check out Gitlab guide if you've never [created a merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html) before.

The repo contains configuration files for PyCharm and pre-commit but feel free to use the IDE of your choice.

### Getting started
1. Choose an issue from the [issue tracker](https://gitlab.com/heg-arc/diesos/diesos/-/issues) or create a new one
2. Create a branch and a merge request from the issue
3. Commit your changes to the branch and push them to the remote repository. The pipelines will run and you'll be able to see the results in the merge request (code style, tests, coverage, translations).
4. Once you are ready, ask for a review
5. A maintainer will take a look at your change and give you feedback or merge it

## Testing

Run all tests

    docker-compose exec django /entrypoint coverage run -m pytest

You can also run tests for a specific app only (faster)

    docker-compose exec django /entrypoint coverage run -m pytest diesos/artefacts

## Style Guide

Run style check

    docker-compose exec django flake8

More detailed output with pylint

    docker-compose exec django /entrypoint pylint --load-plugins pylint_django /app/diesos

## Commit Message Guidelines

These guidelines are based on [robertpainsi commit-message-guidelines.md](https://gist.github.com/robertpainsi/b632364184e70900af4ab688decf6f53).

```
Short (80 chars or less) summary

More detailed explanatory text. Wrap it to 80 characters. The blank
line separating the summary from the body is critical (unless you omit
the body entirely).

Write your commit message in the imperative: "Fix bug" and not "Fixed
bug" or "Fixes bug." This convention matches up with commit messages
generated by commands like git merge and git revert.

Further paragraphs come after blank lines.

- Bullet points are okay, too.
- Typically a hyphen or asterisk is used for the bullet, followed by a
  single space. Use a hanging indent.
```

### Example for a commit message
```
Add pygraphviz to the local build to support database model exports as png

- We can now export the database model using `docker-compose exec django /entrypoint python manage.py graph_models -a -g -o diesos.png`
- For more information see https://django-extensions.readthedocs.io/en/latest/graph_models.html

Fixes #54
```

### A properly formed git commit subject line should always be able to complete the following sentence
If applied, this commit will *\<your subject line here\>*

### Rules for a great git commit message style
* Separate subject from body with a blank line
* Do not end the subject line with a period
* Capitalize the subject line and each paragraph
* Use the imperative mood in the subject line
* Use the body to explain **what and why** you have done something. In most cases, you can leave out details about how a change has been made.

### Information in commit messages
* Describe **why** a change is being made.
* How does it address the issue?
* What effects does the patch have?
* Do not assume the reviewer understands what the original problem was.
* Do not assume the code is self-evident/self-documenting.
* Read the commit message to see if it hints at improved code structure.
* The first commit line is the most important.
* Describe any limitations of the current code.
* Do not include patch set-specific comments.

Details for each point and good commit message examples can be found on https://wiki.openstack.org/wiki/GitCommitMessages#Information_in_commit_messages

### References in commit messages
If the commit refers to an issue, add this information to the commit message header or body. e.g. the Gitlab web platform automatically converts issue ids (e.g. #123) to links referring to the related issue.

In header:
```
[#123] Add support for shortid codes
```
In body (preferred), bottom of the message:
```
Fixes #123, #124
Closes #125
Refs #126 #127
```

### Sources
* http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
* https://wiki.openstack.org/wiki/GitCommitMessages
* http://chris.beams.io/posts/git-commit/
